%define name openupload
%define version 0.4.2
%define release 25
%define httpuser apache

%if 0%{?fedora} >= 11 || 0%{?rhel} >= 5
%global useselinux 1
%else
%global useselinux 0
%endif

Summary: Share big files easily 
Name: %{name}
Version: %{version}
Release: %{release}%{?dist}
License: GPLv2
URL: http://openupload.sourceforge.net/
Group: Applications/Internet
Source: http://sourceforge.net/projects/openupload/files/openupload/v0.4/%{name}-%{version}.tar.gz
Source1: httpd.conf
Source2: cleanup
Source3: cron
Patch1: openupload-0.4.1-imap_auth.patch
Patch2: openupload-0.4.2-http_auth_and_ldap.patch
Patch3: openupload-0.4.2-fr_local_corrections.patch
Patch4: openupload-0.4.2-sanitize_user_input.patch
Patch5: openupload-0.4.2-mail_utf8.patch
Patch6: openupload-0.4.2-ldap_tls.patch
Patch7: openupload-0.4.2-br_after_colon_in_html_notification.patch
Patch8: openupload-0.4.2-fix_mail_footer.patch
BuildArch: noarch
BuildRoot: %{_tmppath}/%{name}-%{version}

Requires: php
Requires: php-gd
Requires: php-ldap
Requires: php-mysql
Requires: httpd
Requires: %{_sbindir}/semanage

%description
http://openupload.sourceforge.net/
Open Upload is an open source extensible PHP application
for fast file upload and download for big (and small) file
sharing, like rapidshare and megaupload.
Multiple authentication methods, database backends,
multilanguage support.

%prep
%setup -q
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1

%build
# empty build

%install

%{__rm} -rf $RPM_BUILD_ROOT
%{__mkdir} -p %{buildroot}/%{_datadir}/%{name}
for a in $(find ./ -mindepth 1 -maxdepth 1 -type d -print); do
    cp -r $a %{buildroot}/%{_datadir}/%{name}/
done
cp *.php %{buildroot}/%{_datadir}/%{name}/

%{__mkdir} -p %{buildroot}/%{_localstatedir}/lib/%{name}
%{__mv} data/* %{buildroot}/%{_localstatedir}/lib/%{name}

sed -i -e "s|/usr/local/share/openupload|%{_datadir}/%{name}/|g" \
       -e "s|\$CONFIG\['INSTALL_ROOT'\].'/data'|'%{_localstatedir}/lib/%{name}'|" \
       %{buildroot}/%{_datadir}/%{name}/www/config.inc.php.example

%{__mkdir} -p %{buildroot}/%{_sysconfdir}/httpd/conf.d/
%{__install} -m 0640 %{SOURCE1} %{buildroot}/%{_sysconfdir}/httpd/conf.d/%{name}.conf

%{__mkdir} -p %{buildroot}/%{_datadir}/%{name}/bin
%{__install} -m 0755 %{SOURCE2} %{buildroot}/%{_datadir}/%{name}/bin/cleanup.php

%{__mkdir} -p %{buildroot}/%{_localstatedir}/log/
touch %{buildroot}/%{_localstatedir}/log/%{name}.log

%{__mkdir} -p %{buildroot}/%{_sysconfdir}/cron.d
%{__install} -m 0644 %{SOURCE3} %{buildroot}/%{_sysconfdir}/cron.d/%{name}
sed -i -e 's/__APACHE__/%{httpuser}/g' %{buildroot}/%{_sysconfdir}/cron.d/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post
%if %{useselinux}
(
# New File context
semanage fcontext -a -s system_u -t httpd_log_t           -r s0 "%{_localstatedir}/log/%{name}.log"
# keep httpd_sys_script_rw_t (httpd_var_lib_t prevent dir creation)
semanage fcontext -a -s system_u -t httpd_sys_script_rw_t -r s0 "%{_localstatedir}/lib/%{name}(/.*)?"
semanage fcontext -a -s system_u -t httpd_var_lib_t -r s0 "%{_datadir}/%{name}/templates_c(/.*)?"
# files created by app
restorecon -R %{_sysconfdir}/%{name}
restorecon -R %{_localstatedir}/lib/%{name}
restorecon -R %{_datadir}/%{name}/templates_c
restorecon -R %{_localstatedir}/log/%{name}.log
) &>/dev/null || :
%endif


%postun
%if %{useselinux}
if [ "$1" -eq "0" ]; then
    # Remove the File Context
    (
    semanage fcontext -d "%{_localstatedir}/log/%{name}.log"
    semanage fcontext -d "%{_localstatedir}/lib/%{name}(/.*)?"
    semanage fcontext -d "%{_datadir}/%{name}/templates_c(/.*)?"
    ) &>/dev/null || :
fi
%endif


%files
%defattr(-,root,root)
%doc README LICENSE INSTALL TODO CHANGELOG
%{_datadir}/%{name}
%dir %attr(770,root,%{httpuser}) %{_localstatedir}/lib/%{name}
%dir %attr(770,root,%{httpuser}) %{_localstatedir}/lib/%{name}/tmp
%dir %attr(775,root,%{httpuser}) %{_datadir}/%{name}/templates_c
%attr(660,root,%{httpuser}) %{_localstatedir}/log/%{name}.log
%config(noreplace) %{_sysconfdir}/httpd/conf.d/%{name}.conf
%config(noreplace) %{_sysconfdir}/cron.d/%{name}


%changelog
* Fri Nov 15 2013 Daniel B. <daniel@firewall-services.com> - 0.4.2-25
- Spec file cleanup

* Fri Jun 28 2013 Daniel B. <daniel@firewall-services.com> - 0.4.2-24
- Drop useless patch2 (Charset UTF-8 in mail header)
- Fix mail_utf8 patch to set the charset to utf8 in the different parts
  (text/plain and text/html)

* Thu May 30 2013 Daniel B. <daniel@firewall-services.com> - 0.4.2-23
- Re-enable patch4 (fr locale corrections)

* Thu Dec 20 2012 Daniel B. <daniel@firewall-services.com> - 0.4.2-22
- Disable PHP output buffering

* Mon Oct 1 2012 Daniel B. <daniel@firewall-services.com> - 0.4.2-21
- Fix multipart headers for mail notifications
- Fix mail notification footer

* Wed Jun 20 2012 Daniel B. <daniel@firewall-services.com> - 0.4.2-20
- Fix buggy br before colon in HTML notification template

* Tue Jun 19 2012 Daniel B. <daniel@firewall-services.com> - 0.4.2-19
- Some other fr localization enhancement

* Tue Jun 19 2012 Daniel B. <daniel@firewall-services.com> - 0.4.2-18
- Patch to support TLS for LDAP server

* Tue Jun 19 2012 Daniel B. <daniel@firewall-services.com> - 0.4.2-17
- Add requires for php-gd, php-mysql and php-ldap
- Add requires semanage

* Tue May 22 2012 Daniel B. <daniel@firewall-services.com> - 0.4.2-16
- More fr locale corrections

* Tue May 22 2012 Daniel B. <daniel@firewall-services.com> - 0.4.2-15
- Support UTF-8 chars in emails

* Wed Sep 28 2011 Daniel B. <daniel@firewall-services.com> - 0.4.2-14
- Don't exit with error if SELinux is disabled

* Fri Sep 09 2011 Daniel B. <daniel@firewall-services.com> - 0.4.2-13
- Fix potential security issue (sanitize user input)

* Wed Jul 27 2011 Daniel B. <daniel@firewall-services.com> - 0.4.2-12
- fr localization fixes

* Wed Jul 27 2011 Daniel B. <daniel@firewall-services.com> - 0.4.2-11
- Fix cleanup script, also removed grouped files

* Mon Jul 04 2011 Daniel B. <daniel@firewall-services.com> 0.4.2-10
- Don't restart apache on install/remove/upgrade

* Fri Mar 18 2011 Daniel B. <daniel@firewall-services.com> 0.4.2-9
- Minor fix in httpldap patch

* Thu Feb 17 2011 Daniel B. <daniel@firewall-services.com> 0.4.2-8
- cleanup httpldap patch

* Wed Jan 05 2011 Daniel B. <daniel@firewall-services.com> 0.4.2-7
- Fix a redirect loop when using HTTP auth

* Thu Jan 04 2011 Daniel B. <daniel@firewall-services.com> 0.4.2-6
- Add patch to support HTTP auth, with a new auth module to
  retrieve user info via LDAP

* Tue Nov 23 2010 Daniel B. <daniel@firewall-services.com> 0.4.2-5
- Upstream upgrade to 0.4.2 (security fix)

* Wed Aug 05 2010 Daniel B. <daniel@firewall-services.com> 0.4.1-5
- Fixe SELinux security context for templates_c dir
- Add Charset: UTF-8 in mail header

* Tue Mar 23 2010 Daniel B. <daniel@firewall-services.com> 0.4.1-4
- Fixe apache user on el
- Add SELinux security contexts

* Mon Mar 22 2010 Daniel B. <daniel@firewall-services.com> 0.4.1-3
- Fixes in apache config
- Update config.inc.php.example to point data dir to /var/lib/openupload

* Thu Mar 11 2010 Daniel B. <daniel@firewall-services.com> 0.4.1-2
- update apache config

* Tue Mar 09 2010 Daniel B. <daniel@firewall-services.com> 0.4.1-1
- initial release
- include patch to support IMAP auth
- include cron job to cleanup expired files

